## openwalnut 1.4.0~rc1+hg3a3147463ee2

=== src/CMakeLists.txt ===
#---------------------------------------------------------------------------
#
# Project: OpenWalnut ( http://www.openwalnut.org )
#
# Copyright 2009 OpenWalnut Community, BSV@Uni-Leipzig and CNCF@MPI-CBS
# For more information see http:#www.openwalnut.org/copying
#
# This file is part of OpenWalnut.
#
# OpenWalnut is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# OpenWalnut is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with OpenWalnut. If not, see <http:#www.gnu.org/licenses/>.
#
#---------------------------------------------------------------------------

# ---------------------------------------------------------------------------------------------------------------------------------------------------
#
# General CMake Setup
#
# ---------------------------------------------------------------------------------------------------------------------------------------------------

CMAKE_MINIMUM_REQUIRED(VERSION 2.8)
PROJECT( OpenWalnut )

# ---------------------------------------------------------------------------------------------------------------------------------------------------
#
# Include the OpenWalnut build system.
#
# ---------------------------------------------------------------------------------------------------------------------------------------------------

# where to find our utils and cmake modules?
SET( OW_TOOLS_DIR ${PROJECT_SOURCE_DIR}/../tools )

# append search path for FindModules:
LIST( APPEND CMAKE_MODULE_PATH ${OW_TOOLS_DIR}/cmake )

# use internally
SET( OW_EXTERNAL_MODULE false )

# These scripts contains all the needed tools to setup the build:
# * Compiler Setup
# * Common OpenWalnut Options
# * Third-party Dependencies Setup
# * Unit Testing Setup if found
# * Doxygen Setup if found
INCLUDE( OpenWalnut )

# ---------------------------------------------------------------------------------------------------------------------------------------------------
#
# Resource/Doc Copy
#  - Resource copy is done by the OW parts. This just copies additional helpers
#
# ---------------------------------------------------------------------------------------------------------------------------------------------------

# copy our debug utilities. This is only useful if compiled debug or RelWithDebInfo
IF( NOT cmake_build_type_tolower STREQUAL "release" )
    # NOTE: DO NOT add and install target here. Debugging tools are not useful and wished in an OpenWalnut installation.
    ADD_CUSTOM_TARGET( CopyDebugUtilities
        ALL
        COMMAND ${CMAKE_COMMAND} -E copy_directory "${PROJECT_SOURCE_DIR}/../tools/debugging" "${PROJECT_BINARY_DIR}/"
        COMMENT "Copying debug utilities"
    )
ENDIF()

# ---------------------------------------------------------------------------------------------------------------------------------------------------
#
# Convenience targets
#
# ---------------------------------------------------------------------------------------------------------------------------------------------------

# some convenience install targets:
ADD_CUSTOM_TARGET( list_install_tarets
                   COMMAND echo The following components can be installed:
                   COMMAND echo " * install - install everything."
                   COMMAND echo " * install_runtime - install the UIs."
                   COMMAND echo " * install_lib - install only libopenwalnut."
                   COMMAND echo " * install_modules - install only the compiled modules."
                   COMMAND echo " * install_dev - install the development headers for libopenwalnut."
                   COMMAND echo " * install_devdoc - install the development documentation for libopenwalnut."
                   COMMENT "List installation targets."
                 )

# install targets for different parts
ADD_CUSTOM_TARGET( install_runtime
                    ${CMAKE_COMMAND}
                        -DCOMPONENT=QT4GUI
                        -P ${CMAKE_BINARY_DIR}/cmake_install.cmake
                 )
ADD_CUSTOM_TARGET( install_lib
                    ${CMAKE_COMMAND}
                        -DCOMPONENT=CORE
                        -P ${CMAKE_BINARY_DIR}/cmake_install.cmake
                    ${CMAKE_COMMAND}
                        -DCOMPONENT=EXT
                        -P ${CMAKE_BINARY_DIR}/cmake_install.cmake
                 )
ADD_CUSTOM_TARGET( install_modules
                    ${CMAKE_COMMAND}
                        -DCOMPONENT=MODULES
                        -P ${CMAKE_BINARY_DIR}/cmake_install.cmake
                 )
ADD_CUSTOM_TARGET( install_dev
                    ${CMAKE_COMMAND}
                        -DCOMPONENT=CORE_DEV
                        -P ${CMAKE_BINARY_DIR}/cmake_install.cmake
                 )
ADD_CUSTOM_TARGET( install_devdoc
                    ${CMAKE_COMMAND}
                        -DCOMPONENT=CORE_DOC
                        -P ${CMAKE_BINARY_DIR}/cmake_install.cmake
                    DEPENDS core_devdoc
                 )
ADD_DEPENDENCIES( install_devdoc core_devdoc )

# ---------------------------------------------------------------------------------------------------------------------------------------------------
#
# Compilation Targets
#  - The GUI + OpenWalnut.cpp ==> openwalnut binary
#  - Ext ==> libOWext_*
#  - All the others ==> libOWcore
#
# ---------------------------------------------------------------------------------------------------------------------------------------------------

# -----------------------------------------------------------------------------------------------------------------------------------------------
# core library

# build core
ADD_SUBDIRECTORY( core )

# -----------------------------------------------------------------------------------------------------------------------------------------------
# QT4 GUI

OPTION( OW_GUI_QT4 "Enable this to build the QT4-based OpenWalnut GUI." ON )
IF( OW_GUI_QT4 )
    # build
    ADD_SUBDIRECTORY( qt4gui )
ENDIF()

# -----------------------------------------------------------------------------------------------------------------------------------------------
# Scripting UI

OPTION( OW_UI_SCRIPT "Enable this to build the script-based OpenWalnut interface for commandline-only use." ON )
IF( OW_UI_SCRIPT )
    # build
    ADD_SUBDIRECTORY( scriptUI )
ENDIF()

# -----------------------------------------------------------------------------------------------------------------------------------------------
# Modules

# build modules
OPTION( OW_MODULE_BUILD "Enable this to build the modules." ON )
IF( OW_MODULE_BUILD )
  ADD_SUBDIRECTORY( modules )
ENDIF()

=== src/core/CMakeLists.txt ===
#---------------------------------------------------------------------------
#
# Project: OpenWalnut ( http://www.openwalnut.org )
#
# Copyright 2009 OpenWalnut Community, BSV@Uni-Leipzig and CNCF@MPI-CBS
# For more information see http:#www.openwalnut.org/copying
#
# This file is part of OpenWalnut.
#
# OpenWalnut is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# OpenWalnut is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with OpenWalnut. If not, see <http:#www.gnu.org/licenses/>.
#
#---------------------------------------------------------------------------

# ---------------------------------------------------------------------------------------------------------------------------------------------------
# Some common setup
# ---------------------------------------------------------------------------------------------------------------------------------------------------

SET( LibName ${OW_LIB_OPENWALNUT} )

# Set the prefix and suffix of dynamically loadable modules to match
# CMAKEs naming of them. The quotes are necessary so the shell doesn't mess
# with these defines. WSharedLib::getSystemPrefix and
# getSystemSuffix hard codes the right strings for VC.
ADD_DEFINITIONS( '-DW_LIB_PREFIX="${CMAKE_SHARED_LIBRARY_PREFIX}"' )
ADD_DEFINITIONS( '-DW_LIB_SUFFIX="${CMAKE_SHARED_LIBRARY_SUFFIX}"' )

OPTION( OW_STATIC_BUILD "Enable this to build the core library as static library." OFF )

# the files to link against if we found the necessary libs for a script interpreter
SET( INTERPRETER_LINK_LIBRARIES )

IF( BUILD_PYTHON_INTERPRETER )
    # Python
    FIND_PACKAGE( PythonLibs REQUIRED )
    
    # Python found?
    IF( PYTHONLIBS_FOUND AND Boost_FOUND )
        INCLUDE_DIRECTORIES( ${Boost_INCLUDE_DIR} ${PYTHON_INCLUDE_DIRS} )
        ADD_DEFINITIONS( -DPYTHON_FOUND )
        SET( INTERPRETER_LINK_LIBRARIES ${INTERPRETER_LINK_LIBRARIES} ${PYTHON_LIBRARIES} )
    ENDIF()
ENDIF() # BUILD_SCRIPTENGINE

# ---------------------------------------------------------------------------------------------------------------------------------------------------
# Add sources as target
# ---------------------------------------------------------------------------------------------------------------------------------------------------

# Collect the compile-files for this target
COLLECT_COMPILE_FILES( "${CMAKE_CURRENT_SOURCE_DIR}" TARGET_CPP_FILES TARGET_H_FILES TARGET_TEST_FILES )

# Setup the target
IF( OW_STATIC_BUILD )
    ADD_LIBRARY( ${LibName} STATIC ${TARGET_CPP_FILES} ${TARGET_H_FILES} ${OW_VERSION_HEADER} )
ELSE()
    ADD_LIBRARY( ${LibName} SHARED ${TARGET_CPP_FILES} ${TARGET_H_FILES} ${OW_VERSION_HEADER} )
ENDIF()

TARGET_LINK_LIBRARIES( ${LibName} ${Boost_LIBRARIES} ${CMAKE_STANDARD_LIBRARIES} ${CMAKE_DL_LIBS} ${OPENGL_gl_LIBRARY} ${OPENSCENEGRAPH_LIBRARIES} ${INTERPRETER_LINK_LIBRARIES}
                     )

# Tell CMake that someone creates this file for us. See doc of SETUP_VERSION_HEADER for details why this is needed.
# NOTE: this needs to be placed AFTER ADD_EXECUTABLE or ADD_LIBRARY
SETUP_USE_VERSION_HEADER( ${LibName} )

# Set the version of the library.
SET_TARGET_PROPERTIES( ${LibName} PROPERTIES 
                       VERSION ${OW_LIB_VERSION} 
                       SOVERSION ${OW_SOVERSION}
)

# Do not forget the install targets
SETUP_LIB_INSTALL( ${LibName} ${OW_LIBRARY_DIR_RELATIVE} "CORE" )

# Core contains the headers which are needed for any developer release. Install them.
# NOTE: do not use ${TARGET_H_FILES}. The command requires a list
SETUP_DEV_INSTALL( ${LibName} ${OW_LIBRARY_DIR_RELATIVE} TARGET_H_FILES "include/openwalnut/core" "CORE_DEV" )
# Install the header too
INSTALL( FILES ${OW_VERSION_HEADER} 
         DESTINATION "include/openwalnut/core"
         COMPONENT "CORE_DEV"
)

# The core does also provide some nice pkg-config file. Set this up and configure it to contain the correct install prefix
SETUP_CONFIGURED_FILE( "core-dev" "lib/pkgconfig/openwalnut.pc" "CORE_DEV" )

# ---------------------------------------------------------------------------------------------------------------------------------------------------
# Test Setup
# ---------------------------------------------------------------------------------------------------------------------------------------------------

# Setup tests of this target
SETUP_TESTS( "${TARGET_TEST_FILES}" "${LibName}" "" )

# ---------------------------------------------------------------------------------------------------------------------------------------------------
# Doxygen Release documentation
# ---------------------------------------------------------------------------------------------------------------------------------------------------

# NOTE: this full documentation also includes call/caller graphs, colaboration graphs and nicer inheritance graphs
# but needs "dot" from graphviz to render them.
SET( DEVDOC_DIR "${PROJECT_SOURCE_DIR}/../doc/core/html" )
ADD_CUSTOM_TARGET( core_devdoc
                   COMMAND doxygen ${PROJECT_SOURCE_DIR}/../doc/core/doxygenConfig
                   COMMAND chmod -R g+r ${DEVDOC_DIR}
                   WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/..
                   COMMENT "Build verbose doxygen documentation for core"
                   VERBATIM
                 )

# ---------------------------------------------------------------------------------------------------------------------------------------------------
# Copy local resources
# ---------------------------------------------------------------------------------------------------------------------------------------------------

# copy our own resources
IF( NOT OW_PACKAGE_NOCOPY_COREFONTS )
    SETUP_GLOBAL_RESOURCES( "core" "CORE" )
ELSE()
    # This is a hack which is quite debian specific. We do this here to avoid font duplicates since the ttf-liberation fonts are already
    # available on Debian. If you need to modify this for another packaging thingy, please let me know (ebaum@informatik.uni-leipzig.d). We then
    # should find a generic solution.
    IF( OW_PACKAGE_PACKAGER STREQUAL "deb" )
        INSTALL( CODE "MESSAGE( \"INSTALL: Symlinking fonts to \${CMAKE_INSTALL_PREFIX}/share/openwalnut/fonts.\" )"
                COMPONENT "CORE" )
        INSTALL( CODE "EXECUTE_PROCESS( COMMAND ${CMAKE_COMMAND} -E make_directory \${CMAKE_INSTALL_PREFIX}/share/openwalnut/fonts )"
                COMPONENT "CORE" ) 
        INSTALL( CODE "EXECUTE_PROCESS( COMMAND ${CMAKE_COMMAND} -E create_symlink /usr/share/fonts/truetype/ttf-liberation/LiberationMono-Bold.ttf \${CMAKE_INSTALL_PREFIX}/share/openwalnut/fonts/Bold.ttf )"
                COMPONENT "CORE" )
        INSTALL( CODE "EXECUTE_PROCESS( COMMAND ${CMAKE_COMMAND} -E create_symlink /usr/share/fonts/truetype/ttf-liberation/LiberationMono-Italic.ttf \${CMAKE_INSTALL_PREFIX}/share/openwalnut/fonts/Italic.ttf )"
                COMPONENT "CORE" )
        INSTALL( CODE "EXECUTE_PROCESS( COMMAND ${CMAKE_COMMAND} -E create_symlink /usr/share/fonts/truetype/ttf-liberation/LiberationMono-Regular.ttf \${CMAKE_INSTALL_PREFIX}/share/openwalnut/fonts/Regular.ttf )"
                COMPONENT "CORE" )
    ELSE()
        MESSAGE( STATUS "Warning: You enabled \"OW_PACKAGE_NOCOPY_COREFONTS\" but packager unknown." ) 
    ENDIF()
ENDIF()

# where to put doc files?
# NOTE: the doc path should match the SONAME of lib. Use this command to query a proper name:
# objdump -p libopenwalnut.so | sed -n -e's/^[[:space:]]*SONAME[[:space:]]*//p' | sed -e's/\([0-9]\)\.so\./\1-/; s/\.so\.//'
SET( OW_DOC_DIR_RELATIVE "share/doc/libopenwalnut1" )
SETUP_COMMON_DOC( ${OW_DOC_DIR_RELATIVE} "CORE" )

# Also add an install target for this
INSTALL( DIRECTORY ${DEVDOC_DIR} 
         DESTINATION ${OW_DOC_DIR_RELATIVE}
         COMPONENT "CORE_DOC"
         OPTIONAL
       )

# ---------------------------------------------------------------------------------------------------------------------------------------------------
# Copy Shaders
# ---------------------------------------------------------------------------------------------------------------------------------------------------

COLLECT_SHADER_FILES( ${CMAKE_CURRENT_SOURCE_DIR} TARGET_GLSL_FILES )
SETUP_SHADERS( "${TARGET_GLSL_FILES}" "${OW_SHARE_DIR_RELATIVE}/shaders" "CORE" )

# ---------------------------------------------------------------------------------------------------------------------------------------------------
# Style Checker
# ---------------------------------------------------------------------------------------------------------------------------------------------------

# setup the stylechecker. Ignore the platform specific stuff.
SETUP_STYLECHECKER( "${LibName}"
                    "${TARGET_CPP_FILES};${TARGET_H_FILES};${TARGET_TEST_FILES};${TARGET_GLSL_FILES}"  # add all these files to the stylechecker
                    "" )                                        # exlude some ugly files

=== src/qt4gui/CMakeLists.txt ===
#---------------------------------------------------------------------------
#
# Project: OpenWalnut ( http://www.openwalnut.org )
#
# Copyright 2009 OpenWalnut Community, BSV@Uni-Leipzig and CNCF@MPI-CBS
# For more information see http:#www.openwalnut.org/copying
#
# This file is part of OpenWalnut.
#
# OpenWalnut is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# OpenWalnut is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with OpenWalnut. If not, see <http:#www.gnu.org/licenses/>.
#
#---------------------------------------------------------------------------

# ---------------------------------------------------------------------------------------------------------------------------------------------------
# Some common setup
# ---------------------------------------------------------------------------------------------------------------------------------------------------

SET( LibName "qt4gui" )
SET( BinName "openwalnut-qt4" )

# ---------------------------------------------------------------------------------------------------------------------------------------------------
# Setup QT4
# ---------------------------------------------------------------------------------------------------------------------------------------------------

# Package dependencies:
SET( QT_USE_QTSQL FALSE )
SET( QT_USE_QTNETWORK FALSE )
SET( QT_USE_QT3SUPPORT FALSE )
FIND_PACKAGE( Qt4 REQUIRED )
MARK_AS_ADVANCED( FORCE QT_QMAKE_EXECUTABLE )

# Includes:
INCLUDE_DIRECTORIES( SYSTEM ${QT_INCLUDE_DIR} )

# Libraries for linking:
SET( QT_LIBS ${QT_QTCORE_LIBRARY}
             ${QT_QTGUI_LIBRARY}
             ${QT_QTOPENGL_LIBRARY}
             ${QT_QTWEBKIT_LIBRARY} )

# If Qt4 Webkit is not available:
IF( NOT QT_QTWEBKIT_FOUND )
    ADD_DEFINITIONS( "-DQT4GUI_NOWEBKIT" )
ENDIF()

# ---------------------------------------------------------------------------------------------------------------------------------------------------
# GUI compilation options
# ---------------------------------------------------------------------------------------------------------------------------------------------------

# ---------------------------------------------------------------------------------------------------------------------------------------------------
# Add sources as target
# ---------------------------------------------------------------------------------------------------------------------------------------------------

# Collect the compile-files for this target
COLLECT_COMPILE_FILES( "${CMAKE_CURRENT_SOURCE_DIR}" TARGET_CPP_FILES TARGET_H_FILES TARGET_TEST_FILES )

# Qt4 Requires all classes with a QWidget stuff inside to be put into the MOC mechanism. We utilize the automoc mechanism here.
SET( GUI_QT4_MOC_HDRS ${TARGET_H_FILES} )
QT4_AUTOMOC( ${TARGET_CPP_FILES} )
SET( AUTOMOC_MOC_OPTIONS "${OW_CPP_FLAGS_INJECT}" )

# This is needed since the mocs will be generated there
INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_BINARY_DIR} )

# Setup the target
ADD_EXECUTABLE( ${BinName} ${TARGET_CPP_FILES} ${TARGET_H_FILES} ${OW_VERSION_HEADER} )

# Some linux distributions need to explicitily link against X11. We add this lib here.
IF( CMAKE_HOST_SYSTEM MATCHES "Linux" )
    SET( ADDITIONAL_TARGET_LINK_LIBRARIES "X11" )
ENDIF()
TARGET_LINK_LIBRARIES( ${BinName} ${OW_LIB_OPENWALNUT} ${QT_LIBS} ${Boost_LIBRARIES} ${ADDITIONAL_TARGET_LINK_LIBRARIES} )

# Tell CMake that someone creates this file for us. See doc of SETUP_VERSION_HEADER for details why this is needed.
# NOTE: this needs to be placed AFTER ADD_EXECUTABLE or ADD_LIBRARY
SETUP_USE_VERSION_HEADER( ${BinName} )

# Do not forget the install targets
INSTALL( TARGETS ${BinName}
            RUNTIME
                DESTINATION ${OW_RUNTIME_DIR_RELATIVE}
                PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE
                            GROUP_READ GROUP_EXECUTE
                            WORLD_READ WORLD_EXECUTE
         COMPONENT "QT4GUI"
        )

# ---------------------------------------------------------------------------------------------------------------------------------------------------
# Test Setup
# ---------------------------------------------------------------------------------------------------------------------------------------------------

# Setup tests of this target
SETUP_TESTS( "${TARGET_TEST_FILES}" "${BinName}" "" )

# ---------------------------------------------------------------------------------------------------------------------------------------------------
# Copy local resources
# ---------------------------------------------------------------------------------------------------------------------------------------------------

# copy our own resources
SETUP_GLOBAL_RESOURCES( ${LibName} "QT4GUI" )

# where to put doc files?
SET( OW_DOC_DIR_RELATIVE "share/doc/openwalnut-qt4" )
SETUP_COMMON_DOC( ${OW_DOC_DIR_RELATIVE} "QT4GUI" )

# also copy all the user documentation we have for qt4gui
SETUP_ADDITIONAL_DIRECTORY( ${OW_DOC_DIR_RELATIVE}
                            ${PROJECT_SOURCE_DIR}/../doc/${LibName}/help/
                            "QT4GUI"
                            TRUE    # this denotes that the contents of doc/user should be copied instead of user directly
                          )  
SETUP_ADDITIONAL_DIRECTORY( ${OW_MAN_DIR_RELATIVE}
                            ${PROJECT_SOURCE_DIR}/../doc/${LibName}/man/
                            "QT4GUI"
                            TRUE    # this denotes that the contents of doc/man should be copied instead of user directly
                          )

# ---------------------------------------------------------------------------------------------------------------------------------------------------
# Style Checker
# ---------------------------------------------------------------------------------------------------------------------------------------------------

# setup the stylechecker. Ignore the platform specific stuff.
SETUP_STYLECHECKER( "${BinName}"
                    "${TARGET_CPP_FILES};${TARGET_H_FILES};${TARGET_TEST_FILES};${TARGET_GLSL_FILES}"  # add all these files to the stylechecker
                    "" )                                                                               # exlude some ugly files

=== src/scriptUI/CMakeLists.txt ===
#---------------------------------------------------------------------------
#
# Project: OpenWalnut ( http://www.openwalnut.org )
#
# Copyright 2009 OpenWalnut Community, BSV@Uni-Leipzig and CNCF@MPI-CBS
# For more information see http:#www.openwalnut.org/copying
#
# This file is part of OpenWalnut.
#
# OpenWalnut is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# OpenWalnut is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with OpenWalnut. If not, see <http:#www.gnu.org/licenses/>.
#
#---------------------------------------------------------------------------

# ---------------------------------------------------------------------------------------------------------------------------------------------------
# Some common setup
# ---------------------------------------------------------------------------------------------------------------------------------------------------

# NOTE: to ensure a uniqe script UI name, add UI to the script lib name. This is used as target name in cmake and is NOT the name of the
# binary.
SET( LibName "${OW_LIB_OPENWALNUTSCRIPT}-UI" )
# NOTE: ensure that this  name is uniqe. It must not match the scripting lib's name
SET( BinaryName "openwalnut-script" )

# ---------------------------------------------------------------------------------------------------------------------------------------------------
# Search additional dependencies
# ---------------------------------------------------------------------------------------------------------------------------------------------------

# ---------------------------------------------------------------------------------------------------------------------------------------------------
# Add sources as target
# ---------------------------------------------------------------------------------------------------------------------------------------------------

# Collect the compile-files for this target
COLLECT_COMPILE_FILES( "${CMAKE_CURRENT_SOURCE_DIR}" TARGET_CPP_FILES TARGET_H_FILES TARGET_TEST_FILES )

# This is needed since the mocs will be generated there
INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_BINARY_DIR} )

# Setup the target
ADD_EXECUTABLE( ${BinaryName} OpenWalnutScript.cpp ${TARGET_CPP_FILES} ${TARGET_H_FILES} ${OW_VERSION_HEADER} )
TARGET_LINK_LIBRARIES( ${BinaryName} ${OW_LIB_OPENWALNUT} ${OW_LIB_OPENWALNUTSCRIPT} ${Boost_LIBRARIES} )

# Tell CMake that someone creates this file for us. See doc of SETUP_VERSION_HEADER for details why this is needed.
# NOTE: this needs to be placed AFTER ADD_EXECUTABLE or ADD_LIBRARY
SETUP_USE_VERSION_HEADER( ${BinaryName} )

# ---------------------------------------------------------------------------------------------------------------------------------------------------
# Test Setup
# ---------------------------------------------------------------------------------------------------------------------------------------------------

# Setup tests of this target
SETUP_TESTS( "${TARGET_TEST_FILES}" "${LibName}" "" )

# ---------------------------------------------------------------------------------------------------------------------------------------------------
# Doxygen Release documentation
# ---------------------------------------------------------------------------------------------------------------------------------------------------

# included in standard developer doc

# ---------------------------------------------------------------------------------------------------------------------------------------------------
# Copy local resources
# ---------------------------------------------------------------------------------------------------------------------------------------------------

# no local resources yet

# ---------------------------------------------------------------------------------------------------------------------------------------------------
# Copy Shaders
# ---------------------------------------------------------------------------------------------------------------------------------------------------

# no shaders

# ---------------------------------------------------------------------------------------------------------------------------------------------------
# Style Checker
# ---------------------------------------------------------------------------------------------------------------------------------------------------

# setup the stylechecker. Ignore the platform specific stuff.
SETUP_STYLECHECKER( "${LibName}"
                    "${TARGET_CPP_FILES};${TARGET_H_FILES};${TARGET_TEST_FILES};${TARGET_GLSL_FILES}"  # add all these files to the stylechecker
                    "" )                                                                               # exlude some ugly files

=== src/modules/data/CMakeLists.txt ===
#---------------------------------------------------------------------------
#
# Project: OpenWalnut ( http://www.openwalnut.org )
#
# Copyright 2009 OpenWalnut Community, BSV@Uni-Leipzig and CNCF@MPI-CBS
# For more information see http:#www.openwalnut.org/copying
#
# This file is part of OpenWalnut.
#
# OpenWalnut is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# OpenWalnut is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with OpenWalnut. If not, see <http:#www.gnu.org/licenses/>.
#
#---------------------------------------------------------------------------

# ---------------------------------------------------------------------------------------------------------------------------------------------------
# Some common setup
# ---------------------------------------------------------------------------------------------------------------------------------------------------

# we use the directory name as module name
GET_FILENAME_COMPONENT( MODULE_NAME ${CMAKE_CURRENT_SOURCE_DIR} NAME )

# ---------------------------------------------------------------------------------------------------------------------------------------------------
# Search own dependencies
# ---------------------------------------------------------------------------------------------------------------------------------------------------

# 1: FindPackage( LibYouNeed )
# 2: INCLUDE_DIRECTORIES( ${LIBYOUNEED_INCLUDE_DIR} )
# 3: LINK_DIRECTORIES( ${LIBYOUNEED_LIBRARY_DIRS} )
# 4: Add ${LIBYOUNEED_LIBRARY} as _MODULE_DEPENDENCIES parameter to SETUP_MODULE


# -----------------------------------------------------------------------------------------------------------------------------------------------
# NiftiLib, at least 2.0.0
# See  http://niftilib.sourceforge.net

# If it is found on the system, the system version is used
SET( OWExtNiftiIOName  "" )

FIND_PACKAGE( niftilib REQUIRED )

IF( NIFTILIB_FOUND )
   MESSAGE( STATUS "Using system installed nifitlib." )
   INCLUDE_DIRECTORIES( ${NIFTILIB_INCLUDE_DIR} )
   SET( OWExtNiftiIOName  ${NIFTILIB_LIBRARY} )
ENDIF()

# -----------------------------------------------------------------------------------------------------------------------------------------------
# BioSig, at least 0.84
# See http://biosig.sourceforge.net

# If it is found on the system, the system version is used
SET( OWExtBioSigName "" )

FIND_PACKAGE( biosig QUIET )
IF( BIOSIG_FOUND )
   MESSAGE( STATUS "Using system installed biosig." )
   INCLUDE_DIRECTORIES( ${BIOSIG_INCLUDE_DIR} )
   SET( OWExtBioSigName  ${BIOSIG_LIBRARY} )
   ADD_DEFINITIONS( "-DWBIOSIG_ENABLED" )
ENDIF()

# -----------------------------------------------------------------------------------------------------------------------------------------------
# other external libs

SET( OWExtEEPName    "openwalnut_eep" )

# libcnt needs absolute inclusion somewhere
INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_SOURCE_DIR}/ext/libeep )
INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_SOURCE_DIR}/ext )

# build external libs in ext/
ADD_SUBDIRECTORY( ext/libeep) # The needed external libraries

# ---------------------------------------------------------------------------------------------------------------------------------------------------
# Setup for compilation
# ---------------------------------------------------------------------------------------------------------------------------------------------------

# Let this function do the job. It sets up tests and copies shaders automatically. It additionally configures the stylecheck mechanism for this
# module.
SETUP_MODULE( ${MODULE_NAME}                # name of the module
             "${CMAKE_CURRENT_SOURCE_DIR}"  # where to find the source ${CMAKE_CURRENT_SOURCE_DIR} is a good idea here mostly
             "${OWExtBioSigName};${OWExtEEPName};${OWExtNiftiIOName}" # does your module need additional libs to compile?
             "ext"                             # do you want to exclude files from stylechecking? (externals for example)
)

=== src/modules/openIGTLink/CMakeLists.txt ===
#---------------------------------------------------------------------------
#
# Project: OpenWalnut ( http://www.openwalnut.org )
#
# Copyright 2009 OpenWalnut Community, BSV@Uni-Leipzig and CNCF@MPI-CBS
# For more information see http:#www.openwalnut.org/copying
#
# This file is part of OpenWalnut.
#
# OpenWalnut is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# OpenWalnut is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with OpenWalnut. If not, see <http:#www.gnu.org/licenses/>.
#
#---------------------------------------------------------------------------

# ---------------------------------------------------------------------------------------------------------------------------------------------------
# Some common setup
# ---------------------------------------------------------------------------------------------------------------------------------------------------

# we use the directory name as module name
GET_FILENAME_COMPONENT( MODULE_NAME ${CMAKE_CURRENT_SOURCE_DIR} NAME )

# ---------------------------------------------------------------------------------------------------------------------------------------------------
# Search own dependencies
# ---------------------------------------------------------------------------------------------------------------------------------------------------

# 1: FindPackage( LibYouNeed )
Find_Package( OpenIGTLink QUIET )

IF( OpenIGTLink_FOUND )
    # 2: INCLUDE_DIRECTORIES( ${LIBYOUNEED_INCLUDE_DIR} )
    INCLUDE_DIRECTORIES( ${OpenIGTLink_INCLUDE_DIRS} )

    # 3: LINK_DIRECTORIES( ${LIBYOUNEED_LIBRARY_DIRS} )
    LINK_DIRECTORIES( ${OpenIGTLink_LIBRARY_DIRS} )
    # 4: Add ${LIBYOUNEED_LIBRARY} as _MODULE_DEPENDENCIES parameter to SETUP_MODULE

    # ---------------------------------------------------------------------------------------------------------------------------------------------------
    # Setup for compilation
    # ---------------------------------------------------------------------------------------------------------------------------------------------------

    # Let this function do the job. It sets up tests and copies shaders automatically. It additionally configures the stylecheck mechanism for this
    # module.
    SETUP_MODULE( ${MODULE_NAME}                # name of the module
                 "${CMAKE_CURRENT_SOURCE_DIR}"  # where to find the source ${CMAKE_CURRENT_SOURCE_DIR} is a good idea here mostly
                  ${OpenIGTLink_LIBRARIES}      # does your module need additional libs to compile?
                  ""                            # do you want to exclude files from stylechecking? (externals for example)
    )
ENDIF( OpenIGTLink_FOUND )

=== debian/changelog ===
openwalnut (1.4.0~rc1+hg3a3147463ee2-1ubuntu2) vivid; urgency=medium

  * No-change rebuild against OpenSceneGraph 3.2.1.

 -- Timo Jyrinki <timo-jyrinki@ubuntu.com>  Fri, 20 Feb 2015 15:21:29 +0200

openwalnut (1.4.0~rc1+hg3a3147463ee2-1ubuntu1) utopic; urgency=low

  * Add option to use OpenGL ES, and make sure that this is built with
    OpenGL ES for armhf (debian/patches/add-opengl-es-option.patch).
     - Previously, OpenGL was automatically pulled in, and this library may
       have been used for building.
  * Fix a typedef conflict error that occurs on armhf by adding a #include
    before any other #include (debian/patches/fix-includes.patch).
    (LP: #1363962)
  * Disable the code that controls line smoothing for OpenGL ES 2.0. The
    symbols used there are available only in OpenGL and OpenGL ES 1.x (not
    2.0) (debian/patches/disable-line-smoothing.patch).

 -- Saikrishna Arcot <saiarcot895@gmail.com>  Fri, 03 Oct 2014 15:10:41 +0100

openwalnut (1.4.0~rc1+hg3a3147463ee2-1) unstable; urgency=low

  * Major functionality and stability improvements.
  * Several bug fixes
  * Changed ttf-liberation dependency to fonts-liberation (Closes: #722405)
  * OpenWalnut now works properly with OpenSceneGraph 3.2 (Closes: #718381)
  * See http://www.openwalnut.org/versions/2

 -- Sebastian Eichelbaum <openwalnut@nemtics.com>  Wed, 19 Mar 2014 17:46:12 +0100

openwalnut (1.3.1-1) unstable; urgency=low

  * Minor changes compared to 1.3.0 but included several bug fixes.
  * See http://www.openwalnut.org/versions/4

 -- Sebastian Eichelbaum <eichelbaum@informatik.uni-leipzig.de>  Tue, 12 Dec 2012 11:26:32 +0100

=== debian/control ===
Source: openwalnut
Section: science
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Sebastian Eichelbaum <openwalnut@nemtics.com>
Uploaders: Yaroslav Halchenko <debian@onerussian.com>, Michael Hanke <michael.hanke@gmail.com>
Build-Depends: debhelper (>= 8.0.0),
               cmake (>= 2.8.0), doxygen (>= 1.6.3), graphviz (>= 2.26.3),
               libgl1-mesa-dev [!armhf] | libgl-dev [!armhf],
               libgles2-mesa-dev [armhf] | libgles2-dev [armhf],
               libopenscenegraph-dev (>= 3.0.0), libopenthreads-dev (>= 3.0.0),
               libqt4-dev (>= 4:4.6.0), libqt4-opengl-dev (>= 4:4.6.0),
               libqtwebkit-dev (>= 2.0.0),
               libboost-dev (>= 1.46.0), libboost-program-options-dev (>= 1.46.0), libboost-thread-dev (>= 1.46.0),
               libboost-filesystem-dev (>= 1.46.0), libboost-date-time-dev (>= 1.46.0), libboost-system-dev (>= 1.46.0),
               libboost-signals-dev (>= 1.46.0), libboost-regex-dev (>= 1.46.0),
               libeigen3-dev (>= 3.0.0),
               libbiosig-dev (>= 0.85.0),
               libnifti-dev (>= 2.0.0),
               zlib1g-dev (>= 1:1.2.3.4.dfsg)
Standards-Version: 3.9.5
Vcs-hg: http://source.openwalnut.org
Vcs-browser: http://source.openwalnut.org
Homepage: http://www.openwalnut.org


Package: libopenwalnut1
Section: libs
Architecture: any
Depends: fonts-liberation (>= 1.0.0), ${shlibs:Depends}, ${misc:Depends}
Suggests: nvidia-glx | fglrx-glx
Description: Framework for multi-modal medical and brain data visualization
 OpenWalnut is a tool for multi-modal medical and brain data visualization. Its
 universality allows it to be easily extended and used in a large variety of
 application cases. It is both, a tool for the scientific user and a powerful
 framework for the visualization researcher. Besides others, it is able to load
 NIfTI data, VTK line data and RIFF-format CNT/AVR-files. OpenWalnut provides
 many standard visualization tools like line integral convolution (LIC),
 isosurface-extraction, glyph-rendering or interactive fiber-data exploration.
 The powerful framework of OpenWalnut allows researchers and power-users to
 easily extend the functionality to their specific needs.
 .
 This package contains the core API of OpenWalnut.


Package: libopenwalnut1-dev
Section: libdevel
Architecture: any
Depends: libopenwalnut1 (= ${binary:Version}),
         libgl1-mesa-dev [!armhf] | libgl-dev [!armhf],
         libgles2-mesa-dev [armhf],
         libopenscenegraph-dev (>= 3.0.0), libopenthreads-dev (>= 3.0.0),
         libboost-dev (>= 1.46.0), libboost-program-options-dev (>= 1.46.0), libboost-thread-dev (>= 1.46.0),
         libboost-filesystem-dev (>= 1.46.0), libboost-date-time-dev (>= 1.46.0), libboost-system-dev (>= 1.46.0),
         libboost-signals-dev (>= 1.46.0), libboost-regex-dev (>= 1.46.0),
         libeigen3-dev (>= 3.0.0),
         ${misc:Depends}
Description: Development files for the OpenWalnut visualization framework
 OpenWalnut is a tool for multi-modal medical and brain data visualization. Its
 universality allows it to be easily extended and used in a large variety of
 application cases. It is both, a tool for the scientific user and a powerful
 framework for the visualization researcher. Besides others, it is able to load
 NIfTI data, VTK line data and RIFF-format CNT/AVR-files. OpenWalnut provides
 many standard visualization tools like line integral convolution (LIC),
 isosurface-extraction, glyph-rendering or interactive fiber-data exploration.
 The powerful framework of OpenWalnut allows researchers and power-users to
 easily extend the functionality to their specific needs.
 .
 This package contains the headers for the core API of OpenWalnut.


Package: libopenwalnut1-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}, libjs-jquery
Description: Developer documentation for the OpenWalnut visualization framework
 OpenWalnut is a tool for multi-modal medical and brain data visualization. Its
 universality allows it to be easily extended and used in a large variety of
 application cases. It is both, a tool for the scientific user and a powerful
 framework for the visualization researcher. Besides others, it is able to load
 NIfTI data, VTK line data and RIFF-format CNT/AVR-files. OpenWalnut provides
 many standard visualization tools like line integral convolution (LIC),
 isosurface-extraction, glyph-rendering or interactive fiber-data exploration.
 The powerful framework of OpenWalnut allows researchers and power-users to
 easily extend the functionality to their specific needs.
 .
 This package contains the core API documentation of OpenWalnut.


Package: openwalnut-modules
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Loaders, algorithms and visualization modules for OpenWalnut
 OpenWalnut is a tool for multi-modal medical and brain data visualization. Its
 universality allows it to be easily extended and used in a large variety of
 application cases. It is both, a tool for the scientific user and a powerful
 framework for the visualization researcher. Besides others, it is able to load
 NIfTI data, VTK line data and RIFF-format CNT/AVR-files. OpenWalnut provides
 many standard visualization tools like line integral convolution (LIC),
 isosurface-extraction, glyph-rendering or interactive fiber-data exploration.
 The powerful framework of OpenWalnut allows researchers and power-users to
 easily extend the functionality to their specific needs.
 .
 This package contains the currently available modules for OpenWalnut.


Package: openwalnut-qt4
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: openwalnut-modules (= ${binary:Version})
Description: Qt based user interface for OpenWalnut
 OpenWalnut is a tool for multi-modal medical and brain data visualization. Its
 universality allows it to be easily extended and used in a large variety of
 application cases. It is both, a tool for the scientific user and a powerful
 framework for the visualization researcher. Besides others, it is able to load
 NIfTI data, VTK line data and RIFF-format CNT/AVR-files. OpenWalnut provides
 many standard visualization tools like line integral convolution (LIC),
 isosurface-extraction, glyph-rendering or interactive fiber-data exploration.
 The powerful framework of OpenWalnut allows researchers and power-users to
 easily extend the functionality to their specific needs.
 .
 This package contains the QT4 GUI for OpenWalnut.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

ifeq (armhf,$(DEB_HOST_ARCH))
ARMHF_DEFINES=-DUSE_OPENGL_ES:BOOL=ON
endif

override_dh_auto_build:
	# Invoke standard build mechanism.
	dh_auto_build
	# build the core api documentation too
	dh_auto_build -- core_devdoc

override_dh_auto_configure:
	# We turn of several build options here to reduce dependencies. Later, several modules are moved to an extra package which then uses cuda/opencl and stuff.
	# NOTE: you can uncomment the last line for faster compilation/package debugging.
	dh_auto_configure -- -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_BUILD_TYPE=Release \
							-DOW_USE_CUDA=OFF\
							-DOW_USE_OPENCL=OFF\
							-DOW_USE_TESTS=OFF\
							-DOW_UI_SCRIPT=OFF\
							-DOW_PACKAGE_BUILD=ON\
								-DOW_PACKAGE_NOCOPY_LICENSE=ON\
								-DOW_PACKAGE_NOCOPY_COREFONTS=ON\
								-DOW_PACKAGE_PACKAGER=deb\
							-DOW_MODULE_TOOLBOX_BASE=ON\
							-DOW_MODULE_TOOLBOX_EEG=ON\
							-DOW_MODULE_TOOLBOX_IO=ON\
							-DOW_MODULE_TOOLBOX_IMAGEPROCESSING=ON\
							-DOW_MODULE_TOOLBOX_OTHERS=ON\
							${ARMHF_DEFINES}\
							-DOW_C_FLAGS_INJECT="$(shell dpkg-buildflags --get CFLAGS)"\
							-DOW_CXX_FLAGS_INJECT="$(shell dpkg-buildflags --get CXXFLAGS)"\
							-DOW_LD_FLAGS_INJECT="$(shell dpkg-buildflags --get LDFLAGS)"\
							-DOW_CPP_FLAGS_INJECT="$(shell dpkg-buildflags --get CPPFLAGS)"

override_dh_auto_install:
	# libopenwalnut1
	cmake -DCOMPONENT=CORE      -DCMAKE_INSTALL_PREFIX=debian/libopenwalnut1/usr -P build/cmake_install.cmake
	cmake -DCOMPONENT=EXT       -DCMAKE_INSTALL_PREFIX=debian/libopenwalnut1/usr -P build/cmake_install.cmake
	# libopenwalnut1-dev
	cmake -DCOMPONENT=CORE_DEV  -DCMAKE_INSTALL_PREFIX=debian/libopenwalnut1-dev/usr -P build/cmake_install.cmake
	cmake -DCOMPONENT=EXT_DEV  -DCMAKE_INSTALL_PREFIX=debian/libopenwalnut1-dev/usr -P build/cmake_install.cmake
	# libopenwalnut1-doc
	# Use jquery from Debian package, so prune shipped one. Taken from https://github.com/neurodebian/statsmodels/tree/debian/debian
	-rm ./doc/core/html/jquery.js
	cmake -DCOMPONENT=CORE_DOC  -DCMAKE_INSTALL_PREFIX=debian/libopenwalnut1-doc/usr -P build/cmake_install.cmake
	# openwalnut-qt4
	cmake -DCOMPONENT=QT4GUI    -DCMAKE_INSTALL_PREFIX=debian/openwalnut-qt4/usr -P build/cmake_install.cmake
	# openwalnut-modules
	cmake -DCOMPONENT=MODULES   -DCMAKE_INSTALL_PREFIX=debian/openwalnut-modules/usr -P build/cmake_install.cmake

%:
	# Ensure that dh finds our source and detects that this is made with cmake
	dh $@ --sourcedirectory=src --builddirectory=build --parallel
